Data Structures | Functions | Variables

# openttd.cpp File Reference

Functions related to starting OpenTTD. More...

`#include "stdafx.h"`
`#include "blitter/factory.hpp"`
`#include "sound/sound_driver.hpp"`
`#include "music/music_driver.hpp"`
`#include "video/video_driver.hpp"`
`#include "fontcache.h"`
`#include "error.h"`
`#include "gui.h"`
`#include "base_media_base.h"`
`#include "saveload/saveload.h"`
`#include "company_func.h"`
`#include "command_func.h"`
`#include "news_func.h"`
`#include "fios.h"`
`#include "aircraft.h"`
`#include "roadveh.h"`
`#include "train.h"`
`#include "ship.h"`
`#include "console_func.h"`
`#include "screenshot.h"`
`#include "network/network.h"`
`#include "network/network_func.h"`
`#include "ai/ai.hpp"`
`#include "ai/ai_config.hpp"`
`#include "settings_func.h"`
`#include "genworld.h"`
`#include "progress.h"`
`#include "strings_func.h"`
`#include "date_func.h"`
`#include "vehicle_func.h"`
`#include "gamelog.h"`
`#include "animated_tile_func.h"`
`#include "roadstop_base.h"`
`#include "elrail_func.h"`
`#include "rev.h"`
`#include "highscore.h"`
`#include "station_base.h"`
`#include "crashlog.h"`
`#include "engine_func.h"`
`#include "core/random_func.hpp"`
`#include "rail_gui.h"`
`#include "core/backup_type.hpp"`
`#include "hotkeys.h"`
`#include "newgrf.h"`
`#include "misc/getoptdata.h"`
`#include "game/game.hpp"`
`#include "game/game_config.hpp"`
`#include "town.h"`
`#include "subsidy_func.h"`
`#include "linkgraph/linkgraphschedule.h"`
`#include <stdarg.h>`

Go to the source code of this file.

## Data Structures
struct | AfterNewGRFScan
| Callback structure of statements to be executed after the NewGRF scan. More...
## Functions
void | CallLandscapeTick ()
void | IncreaseDate ()
| Increases the tick counter, increases date and possibly calls procedures that have to be called daily, monthly or yearly.
void | DoPaletteAnimations ()
void | MusicLoop ()
void | ResetMusic ()
void | CallWindowTickEvent ()
| Dispatch WE_TICK event over all windows.
bool | HandleBootstrap ()
| Handle all procedures for bootstrapping OpenTTD without a base graphics set.
Company * | DoStartupNewCompany (bool is_ai, CompanyID company=INVALID_COMPANY)
| Create a new company and sets all company variables default values.
void | ShowOSErrorBox (const char *buf, bool system)
void CDECL | usererror (const char *s,...)
| Error handling for fatal user errors.
void CDECL | error (const char *s,...)
| Error handling for fatal non-user errors.
void CDECL | ShowInfoF (const char *str,...)
| Shows some information on the console/a popup box depending on the OS.
static void | ShowHelp ()
| Show the help message when someone passed a wrong parameter.
static void | WriteSavegameInfo (const char *name)
static void | ParseResolution (Dimension *res, const char *s)
| Extract the resolution from the given string and store it in the 'res' parameter.
static void | ShutdownGame ()
| Unitializes drivers, frees allocated memory, cleans pools, ...
static void | LoadIntroGame (bool load_newgrfs=true)
| Load the introduction game.
void | MakeNewgameSettingsLive ()
void | OpenBrowser (const char *url)
int | ttd_main (int argc, char *argv[])
void | HandleExitGameRequest ()
static void | MakeNewGameDone ()
static void | MakeNewGame (bool from_heightmap, bool reset_settings)
static void | MakeNewEditorWorldDone ()
static void | MakeNewEditorWorld ()
bool | SafeLoad (const char *filename, int mode, GameMode newgm, Subdirectory subdir, struct LoadFilter *lf=NULL)
| Load the specified savegame but on error do different things.
void | SwitchToMode (SwitchMode new_mode)
static void | CheckCaches ()
| Check the validity of some of the caches.
void | StateGameLoop ()
| State controlling game loop.
static void | DoAutosave ()
| Create an autosave.
void | GameLoop ()
## Variables
char * | _config_file
| Configuration file of OpenTTD.
static const OptionData | _options []
| Options of OpenTTD.

## Detailed Description

Functions related to starting OpenTTD.

Definition in file openttd.cpp.

## Function Documentation

static void CheckCaches | ( |  | ) | `[static]`

Check the validity of some of the caches.

Especially in the sense of desyncs between the cached value and what the value would be when calculated from the 'base' data.

Definition at line 1150 of file openttd.cpp.

References AfterLoadCompanyStats(), SmallVector< T, S >::Append(), Town::cache, GoodsEntry::cargo, Vehicle::cargo, Train::ConsistChanged(), DEBUG, DIAGDIR_NE, DIAGDIR_NW, FillNewGRFVehicleCache(), Vehicle::First(), FOR_ALL_VEHICLES, free(), SpecializedVehicle< Ship, VEH_SHIP >::From(), SpecializedVehicle< Aircraft, VEH_AIRCRAFT >::From(), SpecializedVehicle< RoadVehicle, Type >::From(), SpecializedVehicle< Train, Type >::From(), GroundVehicle< T, Type >::gcache, SmallVector< T, S >::Get(), RoadStop::GetEntry(), Station::goods, Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero >::PoolItem< Tpool >::index, Company::infrastructure, CargoList< Tinst, Tcont >::InvalidateCache(), VehicleCargoList::InvalidateCache(), Vehicle::IsPrimaryVehicle(), IsStandardRoadStopTile(), MemCmpT(), MemCpyT(), Vehicle::Next(), Vehicle::owner, RebuildSubsidisedSourceAndDestinationCache(), RebuildTownCaches(), RoadVehUpdateCache(), BaseVehicle::type, Vehicle::unitnumber, UpdateAircraftCache(), Ship::UpdateCache(), VEH_AIRCRAFT, VEH_ROAD, VEH_SHIP, VEH_TRAIN, Vehicle::vehstatus, VS_CRASHED, and RoadStop::xy.

Referenced by StateGameLoop().

static void DoAutosave | ( |  | ) | `[static]`

Create an autosave.

The default name is "autosave#.sav". However with the setting 'keep_all_autosave' the name defaults to company-name + date

Definition at line 1359 of file openttd.cpp.

References _networking, _settings_client, AUTOSAVE_DIR, DEBUG, GenerateDefaultSaveName(), ClientSettings::gui, INVALID_STRING_ID, GUISettings::keep_all_autosave, lastof, GUISettings::max_num_autosaves, SaveOrLoad(), ShowErrorMessage(), SL_OK, SL_SAVE, strecat(), and WL_ERROR.

Company* DoStartupNewCompany | ( | bool | is_ai,
|  | CompanyID | company = `INVALID_COMPANY` |
| ) |  |  |

Create a new company and sets all company variables default values.

Parameters:

  | is_ai | is an AI company?
  | company | CompanyID to use for the new company

Returns:
  the company struct

Definition at line 527 of file company_cmd.cpp.

void CDECL error | ( | const char * | s,
|  |  | ... |
| ) |  |  |

Error handling for fatal non-user errors.

Parameters:

  | s | the string to print.

Note:
  Does NEVER return.

Definition at line 108 of file openttd.cpp.

References lengthof, and CrashLog::SetErrorMessage().

Referenced by ScriptInfo::AddLabels(), ScriptInfo::AddSetting(), AllocateMap(), ScriptInfo::CheckMethod(), CheckTrainAttachment(), CmdConvertRail(), CmdStartStopVehicle(), CompareFiles(), DisableStaticNewGRFInfluencingNonStaticNewGRFs(), DoCommand(), FileStringReader::FileStringReader(), FileWriter::FileWriter(), BaseMedia< Tbase_set >::GetSet(), GetStringWithArgs(), FileStringReader::HandlePragma(), main(), MallocError(), NetworkExecuteLocalCommandQueue(), FileStringReader::ParseFile(), ReallocError(), ClientNetworkGameSocketHandler::Receive_SERVER_ERROR(), SettingsIniFile::ReportFileError(), SoundDriver_Win32::Start(), strecpy(), and TrainController().

bool HandleBootstrap | ( |  | ) |

Handle all procedures for bootstrapping OpenTTD without a base graphics set.

This requires all kinds of trickery that is needed to avoid the use of sprites from the base graphics set which are pretty interwoven.

Returns:
  True if a base set exists, otherwise false.

Definition at line 213 of file bootstrap_gui.cpp.

References _colour_gradient, _network_available, _video_driver, CheckForMissingGlyphs(), BlitterFactoryBase::GetCurrentBlitter(), BaseMedia< GraphicsSet >::GetUsedSet(), InitializeUnicodeGlyphMap(), VideoDriver::MainLoop(), BaseMedia< GraphicsSet >::SetSet(), and usererror().

static void LoadIntroGame | ( | bool | load_newgrfs = `true` | ) | `[static]`

Load the introduction game.

Parameters:

  | load_newgrfs | Whether to load the NewGRFs or not.

Definition at line 318 of file openttd.cpp.

References _music_driver, _pause_mode, BASESET_DIR, CheckForMissingGlyphs(), CheckForMissingSprites(), COMPANY_FIRST, COMPANY_SPECTATOR, CursorVars::fix_at, GenerateWorld(), GWM_EMPTY, MusicDriver::IsSongPlaying(), ResetGRFConfig(), ResetWindowSystem(), SaveOrLoad(), SetLocalCompany(), SetupColoursAndInitialWindow(), SL_LOAD, SL_OK, and WaitTillGeneratedWorld().

Referenced by AfterNewGRFScan::OnNewGRFsScanned(), and SafeLoad().

static void ParseResolution | ( | Dimension * | res,
|  | const char * | s |
| ) |  |  | `[static]`

Extract the resolution from the given string and store it in the 'res' parameter.

Parameters:

  | res | variable to store the resolution in.
  | s | the string to decompose.

Definition at line 264 of file openttd.cpp.

References max(), and ShowInfoF().

bool SafeLoad | ( | const char * | filename,
|  | int | mode,
|  | GameMode | newgm,
|  | Subdirectory | subdir,
|  | struct LoadFilter * | lf = `NULL` |
| ) |  |  |

Load the specified savegame but on error do different things.

If loading fails due to corrupt savegame, bad version, etc. go back to a previous correct state. In the menu for example load the intro game again.

Parameters:

  | mode | mode of loading, either SL_LOAD or SL_OLD_LOAD
  | newgm | switch to this mode of loading fails due to some unknown error
  | filename | file to be loaded
  | subdir | default directory to look for filename, set to 0 if not needed
  | lf | Load filter to use, if NULL: use filename + subdir.

Definition at line 960 of file openttd.cpp.

References _network_dedicated, _network_server, DEBUG, LoadIntroGame(), LoadWithFilter(), NetworkDisconnect(), SaveOrLoad(), SL_LOAD, SL_OK, SL_OLD_LOAD, and SL_REINIT.

Referenced by VideoDriver_Dedicated::MainLoop(), and ClientNetworkGameSocketHandler::Receive_SERVER_MAP_DONE().

void CDECL ShowInfoF | ( | const char * | str,
|  |  | ... |
| ) |  |  |

Shows some information on the console/a popup box depending on the OS.

Parameters:

  | str | the text to show.

Definition at line 128 of file openttd.cpp.

References lengthof.

Referenced by CheckExternalFiles(), GetFontByFaceName(), GetKeyboardLayout(), InitFreeType(), LoadFreeTypeFont(), ParseResolution(), IniFile::ReportFileError(), and SetDebugString().

static void ShutdownGame | ( |  | ) | `[static]`

Unitializes drivers, frees allocated memory, cleans pools, ...

Generally, prepares the game for shutting down

Definition at line 281 of file openttd.cpp.

References _config_file, _network_available, PoolBase::Clean(), LinkGraphSchedule::Clear(), FioCloseAll(), free(), GamelogReset(), NetworkShutDown(), PT_ALL, ResetNewGRFData(), DriverFactoryBase::ShutdownDrivers(), UninitFreeType(), Game::Uninitialize(), AI::Uninitialize(), and UnInitWindowSystem().

void StateGameLoop | ( |  | ) |

State controlling game loop.

The state must not be changed from anywhere but here. That check is enforced in DoCommand.

Definition at line 1300 of file openttd.cpp.

References _current_company, _date, _date_fract, _pause_mode, _settings_game, AnimateAnimatedTiles(), AUTOSAVE_DIR, CallWindowTickEvent(), CheckCaches(), ClearStorageChanges(), GameSettings::game_creation, AI::GameLoop(), Game::GameLoop(), GameCreationSettings::generation_seed, HasModalProgress(), IncreaseDate(), IsLocalCompany(), lengthof, OWNER_NONE, PM_UNPAUSED, Backup< T >::Restore(), RunTileLoop(), SaveOrLoad(), SL_SAVE, and UpdateLandscapingLimits().

Referenced by ClientNetworkGameSocketHandler::GameLoop().

void CDECL usererror | ( | const char * | s,
|  |  | ... |
| ) |  |  |

Error handling for fatal user errors.

Parameters:

  | s | the string to print.

Note:
  Does NEVER return.

Definition at line 88 of file openttd.cpp.

References _video_driver, lengthof, and Driver::Stop().

Referenced by DEFINE_POOL_METHOD(), FioOpenFile(), HandleBootstrap(), HandleInvalidSpriteRequest(), InitializeLanguagePacks(), LoadGrfFile(), LoadGrfFileIndexed(), LoadNewGRFFile(), LoadNextSprite(), VideoDriver_Win32::MakeWindow(), ReadSprite(), DriverFactoryBase::SelectDriver(), ServerNetworkGameSocketHandler::SendMap(), and SwitchNewGRFBlitter().

## Variable Documentation

const OptionData _options[]`[static]`

Initial value:

     {
       GETOPT_SHORT_VALUE('I'),
       GETOPT_SHORT_VALUE('S'),
       GETOPT_SHORT_VALUE('M'),
       GETOPT_SHORT_VALUE('m'),
       GETOPT_SHORT_VALUE('s'),
       GETOPT_SHORT_VALUE('v'),
       GETOPT_SHORT_VALUE('b'),

      GETOPT_SHORT_OPTVAL('D'),
      GETOPT_SHORT_OPTVAL('n'),
       GETOPT_SHORT_VALUE('l'),
       GETOPT_SHORT_VALUE('p'),
       GETOPT_SHORT_VALUE('P'),

       GETOPT_SHORT_NOVAL('f'),

       GETOPT_SHORT_VALUE('r'),
       GETOPT_SHORT_VALUE('t'),
      GETOPT_SHORT_OPTVAL('d'),
       GETOPT_SHORT_NOVAL('e'),
      GETOPT_SHORT_OPTVAL('g'),
       GETOPT_SHORT_VALUE('G'),
       GETOPT_SHORT_VALUE('c'),
       GETOPT_SHORT_NOVAL('x'),
       GETOPT_SHORT_VALUE('q'),
       GETOPT_SHORT_NOVAL('h'),

    }

Options of OpenTTD.

Definition at line 495 of file openttd.cpp.